SystemOrganization addCategory: #'Seaside-WebSocket-WebClient'!

WAWebSocketCreator subclass: #WAWebClientWebSocketCreator
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-WebSocket-WebClient'!

!WAWebClientWebSocketCreator commentStamp: '<historical>' prior: 0!
I create WAWebSockets from WebRequests.
		
Instance Variables:
	request	<WebRequest>
		
request
	- the "native" WebClient request from which to create web sockets!

!WAWebClientWebSocketCreator class methodsFor: 'instance creation' stamp: 'pmm 8/1/2010 13:33'!
on: aWebRequest
	^ self basicNew
		initializeWith: aWebRequest;
		yourself! !

!WAWebClientWebSocketCreator methodsFor: 'initialization' stamp: 'pmm 8/1/2010 13:32'!
initializeWith: aWebRequest
	self initialize.
	request := aWebRequest! !

!WAWebClientWebSocketCreator methodsFor: 'instance creation' stamp: 'pmm 8/1/2010 13:40'!
newWebSocket
	^ WAWebClientWebSocket on: request asWebSocket! !

!WAWebServerAdaptor methodsFor: '*seaside-websocket-webclient' stamp: 'pmm 8/1/2010 14:27'!
contextFor: aWebRequest
	^ (super contextFor: aWebRequest)
		webSocketCreator: (WAWebClientWebSocketCreator on: aWebRequest)
		yourself! !

WAWebSocket subclass: #WAWebClientWebSocket
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-WebSocket-WebClient'!

!WAWebClientWebSocket commentStamp: '<historical>' prior: 0!
I am a WebSocket that delegates to the WebClient implemenation.

Instance Variables:
	delegate	<WebSocket>
		
delegate
	- the "native" WebClient WebSocket to delegate to!

!WAWebClientWebSocket class methodsFor: 'instance creation' stamp: 'pmm 8/1/2010 13:18'!
on: aWebSocket
	^ self basicNew
		initializeWith: aWebSocket;
		yourself! !

!WAWebClientWebSocket methodsFor: 'running' stamp: 'pmm 8/1/2010 13:49'!
fork
	delegate fork! !

!WAWebClientWebSocket methodsFor: 'initialization' stamp: 'pmm 8/1/2010 13:17'!
initializeWith: aWebSocket
	self initialize.
	delegate := aWebSocket! !

!WAWebClientWebSocket methodsFor: 'events' stamp: 'pmm 8/1/2010 13:23'!
onClose: aNiladicBlock
	delegate onClose: aNiladicBlock! !

!WAWebClientWebSocket methodsFor: 'events' stamp: 'pmm 12/1/2010 19:27'!
onError: aOneArgumentBlock
	delegate onError: aOneArgumentBlock! !

!WAWebClientWebSocket methodsFor: 'events' stamp: 'pmm 8/1/2010 13:23'!
onMessage: aOnceOrTwoArgumentBlock
	delegate onMessage: aOnceOrTwoArgumentBlock! !

!WAWebClientWebSocket methodsFor: 'running' stamp: 'pmm 8/1/2010 13:48'!
run
	delegate run! !

!WAWebClientWebSocket methodsFor: 'sending' stamp: 'pmm 8/1/2010 13:24'!
send: aString
	delegate send: aString! !

!WAWebClientWebSocket methodsFor: 'accessing' stamp: 'pmm 8/1/2010 13:54'!
timeout: seconds
	delegate timeout: seconds! !
